Only in kaffe/FAQ: FAQ.ps2linux
Only in kaffe/config: jit-md.h
diff -r -c3 kaffe.cvs/config/mips/common.h kaffe/config/mips/common.h
*** kaffe.cvs/config/mips/common.h	Sun Dec 15 18:48:02 2002
--- kaffe/config/mips/common.h	Wed Dec 18 12:26:25 2002
***************
*** 15,20 ****
--- 15,32 ----
  #ifndef __mips_common_h
  #define __mips_common_h
  
+ /* The R5900 is the Mips Core in the PS2 (Playstation 2)
+ * It has most of the Mips III instructions set, some of the Mips IV 
+ * instructions, it lacks the Mips II "ll" and "sc" instructions and 
+ * it has 128 bit GP registers and 32 bit FPU registers. There is no 
+ * FPU Emulation present in the default kernel. Since no 64 bit
+ * FPU registers exist, doubles are passed in 2 GP registers.
+ */
+ #ifdef _R5900
+ #define PS2LINUX
+ #undef HAVE_MIPSII_INSTRUCTIONS
+ #endif 
+ 
  #if NEED_sysdepCallMethod
  
  #if !defined (_MIPS_SIM) || (_MIPS_SIM == _MIPS_SIM_ABI32)
diff -r -c3 kaffe.cvs/config/mips/linux/md.h kaffe/config/mips/linux/md.h
*** kaffe.cvs/config/mips/linux/md.h	Sun Dec 15 18:48:02 2002
--- kaffe/config/mips/linux/md.h	Wed Dec 18 12:46:34 2002
***************
*** 19,25 ****
--- 19,30 ----
  #undef	FP_OFFSET
  
  #define	SP_OFFSET	1
+ 
+ #ifdef PS2LINUX
+ #define FP_OFFSET	36
+ #else
  #define	FP_OFFSET	10
+ #endif
  
  #if defined(TRANSLATOR)
  #include "jit-md.h"
diff -r -c3 kaffe.cvs/config/mips/o32-sysdepCallMethod.h kaffe/config/mips/o32-sysdepCallMethod.h
*** kaffe.cvs/config/mips/o32-sysdepCallMethod.h	Sun Dec 15 18:48:02 2002
--- kaffe/config/mips/o32-sysdepCallMethod.h	Wed Dec 18 12:23:50 2002
***************
*** 103,110 ****
--- 103,120 ----
      register ARG_TYPE a2 asm("$6");
      register ARG_TYPE a3 asm("$7");
  
+ #ifdef PS2LINUX
+     union {
+         double d;
+         struct {
+             int hi;
+             int lo;
+         } fake_double;
+     } split;
+ #else
      register double d0 asm("$f12");
      register double d2 asm("$f14");
+ #endif
  
      register float f0 asm("$f12");
      register float f2 asm("$f14");
***************
*** 132,140 ****
        }
        
        if (calltype[2] == D) {
! 	  d2 = callargs[2].d;
  	  if(calltype[0] == D) d0 = callargs[0].d;
  	  else f0 = callargs[0].f;
  	  goto alldone;
        }
  
--- 142,166 ----
        }
        
        if (calltype[2] == D) {
! #ifdef PS2LINUX
!           split.d = callargs[2].d;
!           a2 = split.fake_double.hi;
!           a3 = split.fake_double.lo;
! #else
!           d2 = callargs[2].d;
! #endif
! #ifdef PS2LINUX
!           if ( calltype[0] == D) {
!               split.d = callargs[0].d;
!               a0 = split.fake_double.hi;
!               a1 = split.fake_double.lo;
!           } else {
!               f0 = callargs[0].f;
!           }
! #else
  	  if(calltype[0] == D) d0 = callargs[0].d;
  	  else f0 = callargs[0].f;
+ #endif
  	  goto alldone;
        }
  
***************
*** 156,162 ****
--- 182,194 ----
  
    case 2:
        if (calltype[0] == D) {
+ #ifdef PS2LINUX
+           split.d = callargs[0].d;
+           a0 = split.fake_double.hi;
+           a1 = split.fake_double.lo;
+ #else
  	  d0=callargs[0].d;
+ #endif
  	  goto alldone;
        } else {
  	  if (calltype[0] != F) {
***************
*** 188,194 ****
--- 220,230 ----
    noargs:
  #endif
      /* Ensure that the assignments to f* registers won't be optimized away. */
+ #ifdef PS2LINUX
+     asm ("" :: "f" (f0), "f" (f2));
+ #else
      asm ("" :: "f" (f0), "f" (f2), "f" (d0), "f" (d2));
+ #endif
  
      switch(call->retsize) {
      case 0:
Only in kaffe.cvs/config: stamp-h1.in
Only in kaffe.cvs/include: stamp-h2.in
Only in kaffe/kaffe/kaffe: version-info.h
Only in kaffe/kaffe/xprof: Makefile
Only in kaffe/libraries: Makefile
Only in kaffe/libraries/clib/awt/qt: Makefile
Only in kaffe/test/regression: serializedFoos.bin
